unit Test;
{
Copyright 1996 by Justin Turberville
EMail: justint@cyberjoe.co.za

I use this project and test dialog for developing the QueryInfo component
pack and have included it as it is usefull for sampling the components
without first having to install them as they are manually created and set.
Experiment with their properties in FormCreate below as I have done.
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, DBTables, DB, StdCtrls, ExtCtrls, Buttons,
  qiField, qiFldsEd, qiTblsEd, qiJnsEd, qiQuery, qiFormat, qiFilter,
  qiLookup, qiOrder, qiClrsEd, qiSelect, qiGroup, MemoDlg, qiArchiv,
  qiWdw, qiFrBldr, qiUpdate, qiModify, ComCtrls;

type
  TTestForm = class(TForm)
    Orders: TTable;
    Customers: TTable;
    CustomersCustNo: TFloatField;
    CustomersCompany: TStringField;
    CustomersAddr1: TStringField;
    CustomersAddr2: TStringField;
    CustomersCity: TStringField;
    CustomersState: TStringField;
    CustomersZip: TStringField;
    CustomersCountry: TStringField;
    CustomersPhone: TStringField;
    CustomersFAX: TStringField;
    CustomersTaxRate: TFloatField;
    CustomersContact: TStringField;
    CustomersLastInvoiceDate: TDateTimeField;
    OrdersOrderNo: TFloatField;
    OrdersCustNo: TFloatField;
    OrdersSaleDate: TDateTimeField;
    OrdersShipDate: TDateTimeField;
    OrdersEmpNo: TIntegerField;
    OrdersShipToContact: TStringField;
    OrdersShipToAddr1: TStringField;
    OrdersShipToAddr2: TStringField;
    OrdersShipToCity: TStringField;
    OrdersShipToState: TStringField;
    OrdersShipToZip: TStringField;
    OrdersShipToCountry: TStringField;
    OrdersShipToPhone: TStringField;
    OrdersShipVIA: TStringField;
    OrdersPO: TStringField;
    OrdersTerms: TStringField;
    OrdersPaymentMethod: TStringField;
    OrdersItemsTotal: TCurrencyField;
    OrdersTaxRate: TFloatField;
    OrdersFreight: TCurrencyField;
    OrdersAmountPaid: TCurrencyField;
    TestPages: TPageControl;
    QuerySheet: TTabSheet;
    UpdateSheet: TTabSheet;
    Label2: TLabel;
    SQLQueryMemo: TMemo;
    Label3: TLabel;
    UserQueryMemo: TMemo;
    SelectBtn: TButton;
    GroupBtn: TButton;
    SortBtn: TButton;
    ExecuteBtn: TButton;
    EditBtn: TButton;
    TablesBtn: TButton;
    FieldsBtn: TButton;
    JoinsBtn: TButton;
    Label1: TLabel;
    SQLUpdateMemo: TMemo;
    Label4: TLabel;
    UserUpdateMemo: TMemo;
    UpdateBtn: TButton;
    ApplyBtn: TButton;
    LoadBtn: TButton;
    StoreBtn: TButton;
    QueryFilterBtn: TButton;
    UpdateFilterBtn: TButton;
    KindRadios: TRadioGroup;
    UpdateQuery: TQuery;
    LookupBtn: TButton;
    FindNextBtn: TButton;
    FilterColorsBtn: TButton;
    BuildFilterBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure QueryFilterBtnClick(Sender: TObject);
    procedure LookupBtnClick(Sender: TObject);
    procedure SortBtnClick(Sender: TObject);
    procedure FilterColorsBtnClick(Sender: TObject);
    procedure SelectBtnClick(Sender: TObject);
    procedure ExecuteBtnClick(Sender: TObject);
    procedure GroupBtnClick(Sender: TObject);
    procedure EditBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure StoreBtnClick(Sender: TObject);
    procedure FindNextBtnClick(Sender: TObject);
    procedure BuildFilterBtnClick(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TablesBtnClick(Sender: TObject);
    procedure FieldsBtnClick(Sender: TObject);
    procedure JoinsBtnClick(Sender: TObject);
    procedure UpdateBtnClick(Sender: TObject);
    procedure ApplyBtnClick(Sender: TObject);
    procedure UpdateFilterBtnClick(Sender: TObject);
    procedure KindRadiosClick(Sender: TObject);
    procedure TestPagesChange(Sender: TObject);
  private
    FieldInfo: TFieldInfo;
    QueryInfo: TQueryInfo;
    Formatter: TQIFormatter;
    SelectDlg: TQISelectDialog;
    FilterDlg: TQIFilterDialog;
    LookupDlg: TQILookupDialog;
    SortDlg:   TQIOrderDialog;
    GroupDlg:  TQIGroupDialog;
    EditDlg:   TMemoDialog;
    QueryWdw:  TQIQueryWindow;
    Archiver:  TQIArchiver;
    FilterBldr: TQIFilterBuilder;
    UpdateInfo: TUpdateInfo;
    ModifyDlg:  TQIModifyDialog;
    procedure QueryInfoChange(Sender: TObject);
    procedure UpdateInfoChange(Sender: TObject);
    procedure QueryClosed(Sender: TObject);
  end;

var
  TestForm: TTestForm;

implementation

{$R *.DFM}

procedure TTestForm.FormCreate(Sender: TObject);
begin
  FieldInfo := TFieldInfo.Create(Self);
  with FieldInfo do begin
    DatabaseName := 'DBDEMOS';
    AutoJoin := True;    {defaults to true so this is not necessary}
    Tables.AddFromTable(Customers);
    Tables.AddFromTable(Orders);
    with Fields do begin
{     AddFromField(CustomersCustNo).UserName := 'Customer#'; - added by AutoJoin}
      AddFromField(CustomersCompany);
      AddFromField(CustomersAddr1).UserName := 'Address';
      AddFromField(CustomersCity);
      AddFromField(OrdersOrderNo).UserName := 'Order#';
      AddFromField(OrdersEmpNo).UserName := 'Employee#';
{     AddFromField(OrdersCustNo).FieldUsage := [];     - added by Auto-Join}
      AddFromField(OrdersAmountPaid);
      AddFrom('Commission', '', 'ORDERS.AmountPaid * 0.125',
        Tables.ByTableRef(Orders), ftCurrency, [fuSelect..fuLookup], nil);
      AddFromField(OrdersPaymentMethod);
      AddFromField(OrdersSaleDate);
      with ByTableAndSQLName('CUSTOMER.DB', 'CustNo') do begin  {auto added}
        UserName := 'Customer#';                      {set properties -}
        FieldUsage := [fuSelect..fuLookup];
        FieldRef := CustomersCustNo;
      end;
      with BySQLName('OrderNo') do begin             {added by AutoJoin}
        UserName := 'Order#';
        FieldUsage := [fuSelect..fuLookup];
        FieldRef := OrdersOrderNo;
      end;
  {   Joins.AddFrom(ByFieldRef(CustomerCustNo), ByFieldRef(OrdersCustNo), qoEquals); -done via FieldInfo.AutoJoin}
    end;
  end;

  QueryInfo := TQueryInfo.Create(Self);
  with QueryInfo do begin
    FieldInfo := Self.FieldInfo;
    OnChange := QueryInfoChange;
  end;

  UpdateInfo := TUpdateInfo.Create(Self);
  with UpdateInfo do begin
    FieldInfo := Self.FieldInfo;
    OnChange := UpdateInfoChange;
  end;

  Formatter := TQIFormatter.Create(Self);
  with Formatter do begin
    QueryInfo := Self.QueryInfo;
    UpdateInfo := Self.UpdateInfo;
  end;

  ModifyDlg := TQIModifyDialog.Create(Self);
  with ModifyDlg do begin
    UpdateInfo := Self.UpdateInfo;
{   OnFilter := FilterBtnClick;}
{   Aggregates := Aggregates - [qaAve];}
{   ShowGlyphs := True;}
  end;

  SelectDlg := TQISelectDialog.Create(Self);
  with SelectDlg do begin
    QueryInfo := Self.QueryInfo;
{   OnGrouping := GroupBtnClick;}
{   Aggregates := Aggregates - [qaAve];}
{   ShowGlyphs := True;}
  end;

  FilterDlg := TQIFilterDialog.Create(Self);
  with FilterDlg do begin
    QueryInfo := Self.QueryInfo;
    UpdateInfo := Self.UpdateInfo;
{   OnOrdering := SortBtnClick;}
{   Operators := Operators - [qoLike];}
{   ShowGlyphs := True;}
{   SortFields := True;}
  end;

  SortDlg := TQIOrderDialog.Create(Self);
  with SortDlg do begin
    QueryInfo := Self.QueryInfo;
{   AscArrowColor := clBlue;}
{   ShowGlyphs := True;}
{   SortFields := True;}
  end;

  GroupDlg := TQIGroupDialog.Create(Self);
  with GroupDlg do begin
    QueryInfo := Self.QueryInfo;
{   ShowGlyphs := True;}
{   SortFields := True;}
  end;

  EditDlg := TMemoDialog.Create(Self);
  with EditDlg do begin
    Caption := 'SQL Script Editor';
{   BorBtns := True;}
  end;

  QueryWdw := TQIQueryWindow.Create(Self);
  with QueryWdw do begin
    QueryInfo := Self.QueryInfo;
    RequestLive := False;
    OnQueryClosed := QueryClosed;
{   OnSelect := SelectBtnClick;
    OnFilter := FilterBtnClick;
    OnOrder  := SortBtnClick;
    OnEdit := EditBtnClick;
    OnLoad := LoadBtnClick;
    OnSave := StoreBtnClick;
    OnLookup := EditBtnClick;
    OnFindNext := EditBtnClick;
    OnPrint := EditBtnClick;
    OnReport := EditBtnClick;}
  end;

  LookupDlg := TQILookupDialog.Create(Self);
  with LookupDlg do begin
    QueryInfo := Self.QueryInfo;
{   ShowGlyphs := True;}
  end;

  Archiver := TQIArchiver.Create(Self);
  with Archiver do begin
    QueryInfo := Self.QueryInfo;
    KeepOpen := True;
    Browse := False;
    StoreFields := True;
    LoadCaption := 'Load Query Script';
{   ShowGlyphs := True;}
  end;

  FilterBldr := TQIFilterBuilder.Create(Self);
  with FilterBldr do begin
    QueryInfo := Self.QueryInfo;
    Colors.BkgndColor := clCream;
{   OnOrdering := SortBtnClick;}
{   ShowGlyphs := True;}
{   SortFields := True;}
  end;

  QueryInfoChange(nil);
end;

procedure TTestForm.FormDestroy(Sender: TObject);
begin
  Formatter.Free;
  ModifyDlg.Free;
  SelectDlg.Free;
  FilterDlg.Free;
  LookupDlg.Free;
  SortDlg.Free;
  GroupDlg.Free;
  EditDlg.Free;
  QueryWdw.Free;
  Archiver.Free;
  FilterBldr.Free;
  QueryInfo.Free;
  UpdateInfo.Free;
  FieldInfo.Free;
end;

{Note that the following three procedures invoke what are really
 design time only property editors - eg. EditFields invokes the Fields
 property editor. A runtime editor itself should call ChangeNotify if
 the edit is applied, passing the list that was edited. See ChangeNotify
 in qiField.hlp & qiQuery.hlp}

procedure TTestForm.TablesBtnClick(Sender: TObject);
begin
  if EditTables(FieldInfo) then
    FieldInfo.ChangeNotify(FieldInfo.Tables);
end;

procedure TTestForm.FieldsBtnClick(Sender: TObject);
begin
  if EditFields(FieldInfo) then
    FieldInfo.ChangeNotify(FieldInfo.Fields);
end;

procedure TTestForm.JoinsBtnClick(Sender: TObject);
begin
  if EditJoins(FieldInfo) then
    FieldInfo.ChangeNotify(FieldInfo.Joins);
end;

procedure TTestForm.SelectBtnClick(Sender: TObject);
begin
  SelectDlg.Execute;
end;

procedure TTestForm.QueryFilterBtnClick(Sender: TObject);
begin
  FilterDlg.Execute(fkQuery)
end;

procedure TTestForm.SortBtnClick(Sender: TObject);
begin
  SortDlg.Execute;
end;

procedure TTestForm.GroupBtnClick(Sender: TObject);
begin
  GroupDlg.Execute;
end;

procedure TTestForm.EditBtnClick(Sender: TObject);
begin
  if TestPages.ActivePage = QuerySheet then
    EditDlg.Execute(SQLQueryMemo.Lines) else
    EditDlg.Execute(SQLUpdateMemo.Lines);
end;

procedure TTestForm.LookupBtnClick(Sender: TObject);
begin
  with LookupDlg do begin
    DataSet := TDBDataSet(QueryWdw.QuerySource.DataSet);
    if Execute and LookupFirst then begin
      QueryWdw.Show;
      FindNextBtn.Enabled := True;
    end;
  end;
end;

procedure TTestForm.FindNextBtnClick(Sender: TObject);
begin
  FindNextBtn.Enabled := LookupDlg.LookupNext;
  if FindNextBtn.Enabled then
    QueryWdw.Show;
end;

procedure TTestForm.LoadBtnClick(Sender: TObject);
begin
  QueryInfo.OnChange := nil;      {prevent several updates at once}
  if Archiver.Load then QueryInfoChange(nil);
  QueryInfo.OnChange := QueryInfoChange;
  TestPages.ActivePage := QuerySheet;
end;

procedure TTestForm.StoreBtnClick(Sender: TObject);
begin
  Archiver.Store('', UserQueryMemo.Lines);
end;

procedure TTestForm.BuildFilterBtnClick(Sender: TObject);
begin
  FilterBldr.Execute;
end;

procedure TTestForm.FilterColorsBtnClick(Sender: TObject);
begin
  FilterColorsForm := TFilterColorsForm.Create(Self);
  with FilterColorsForm do
  try
    Colors := FilterBldr.Colors;
    ShowModal;
  finally
    Free;
  end;
end;

procedure TTestForm.ExecuteBtnClick(Sender: TObject);
begin
  with QueryWdw do begin
    SQLScript.Assign(SQLQueryMemo.Lines);
{   DisplayScript.Assign(UserQueryMemo.Lines);}
    LookupBtn.Enabled := OpenQuery;
  end;
  FindNextBtn.Enabled := False;
end;

procedure TTestForm.QueryInfoChange(Sender: TObject);
begin
  Formatter.SQLQueryScript(SQLQueryMemo.Lines);
  Formatter.UserQueryScript(UserQueryMemo.Lines);
end;

procedure TTestForm.UpdateInfoChange(Sender: TObject);
begin
  Formatter.SQLUpdateScript(SQLUpdateMemo.Lines);
  Formatter.UserUpdateScript(UserUpdateMemo.Lines);
  ApplyBtn.Enabled := (UpdateInfo.Updates.Count > 0) or
    ((KindRadios.ItemIndex = 2{ukDelete}) and (UpdateInfo.UpdateTable <> nil));
  UpdateFilterBtn.Enabled := ApplyBtn.Enabled and
    (KindRadios.ItemIndex <> 1{ukInsert});
end;

procedure TTestForm.FormDblClick(Sender: TObject);
begin
  QueryWdw.GetFormImage;
end;

procedure TTestForm.UpdateBtnClick(Sender: TObject);
begin
  ModifyDlg.Execute;
end;

procedure TTestForm.UpdateFilterBtnClick(Sender: TObject);
begin
  FilterDlg.Execute(fkUpdate);
end;

procedure TTestForm.ApplyBtnClick(Sender: TObject);
var
  s: string;
begin
  if KindRadios.ItemIndex = 2{ukDelete} then begin    {confirm delete -}
    if UpdateInfo.Filters.Count = 0 then
      s := 'ALL' else
      s := 'filtered';
    if MessageDlg('Deleting ' + s + ' records in ' +
      UpdateInfo.UpdateTable.UserName + ' !!!', mtWarning,
      [mbOK, mbCancel], 0) <> mrOK then Exit;
  end;
  UpdateQuery.SQL.Assign(SQLUpdateMemo.Lines);
  UpdateQuery.ExecSQL;
  MessageDlg('Update successfully completed!', mtInformation, [mbOK], 0);
end;

procedure TTestForm.KindRadiosClick(Sender: TObject);
begin
  UpdateInfo.UpdateKind := TUpdateKind(KindRadios.ItemIndex);
  UpdateInfoChange(nil);
end;

procedure TTestForm.QueryClosed(Sender: TObject);
begin
  LookupBtn.Enabled := False;
  FindNextBtn.Enabled := False;
end;

procedure TTestForm.TestPagesChange(Sender: TObject);
begin
  BuildFilterBtn.Enabled := TestPages.ActivePage = QuerySheet;
end;

end.
